Wt: Wt::Auth::PasswordVerifier Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions
Wt::Auth::PasswordVerifier Class Reference
Authentication module (Wt::Auth)

Password hash computation and verification class. More...

`#include <Wt/Auth/PasswordVerifier>`

Inheritance diagram for Wt::Auth::PasswordVerifier:
[legend]

List of all members.

## Public Member Functions
| PasswordVerifier ()
| Constructor.
virtual | ~PasswordVerifier ()
| Destructor.
void | setSaltLength (int words)
| Sets the salt length.
int | saltLength () const
| Returns the salt length.
void | addHashFunction (HashFunction *function)
| Adds a hash function.
const std::vector < HashFunction * > & | hashFunctions () const
| Returns the list of hash functions.
virtual bool | needsUpdate (const PasswordHash &hash) const
| Returns whether a password hash needs to be updated (recomputed).
virtual PasswordHash | hashPassword (const WString &password) const
| Computes the password hash for a clear text password.
virtual bool | verify (const WString &password, const PasswordHash &hash) const
| Verifies a password against a hash.

## Detailed Description

Password hash computation and verification class.

This class implements the logic for comparing passwords against password hashes, or computing a new password hash for a password.

One or more hash functions can be added, which allow you to introduce a new "preferred" hash function while maintaining support for verifying existing passwords hashes.

## Member Function Documentation

void Wt::Auth::PasswordVerifier::addHashFunction | ( | HashFunction * | function | ) |

Adds a hash function.

The first hash function added is the one that will be used for creating new password hashes, i.e. the "preferred" hash function. The other hash functions are used only for verifying existing hash passwords. This allows you to move to new hash functions as other ones are no longer deemed secure.

Each hash function has a unique name, which is annotated in the generated hash to identify the appropriate hash funtion to evaluate it.

Ownership of the hash functions is transferred.

See also:
  hashFunctions()

const std::vector<HashFunction *>& Wt::Auth::PasswordVerifier::hashFunctions | ( |  | ) | const

Returns the list of hash functions.

This returns a list with references to hashfunctions that have been added with addHashFunction().

PasswordHash Wt::Auth::PasswordVerifier::hashPassword | ( | const WString & | password | ) | const`[virtual]`

Computes the password hash for a clear text password.

This creates new salt and applies the "preferred" hash function to the salt and clear text password to compute the hash.

See also:
  verify()

Implements Wt::Auth::PasswordService::AbstractVerifier.

bool Wt::Auth::PasswordVerifier::needsUpdate | ( | const PasswordHash & | hash | ) | const`[virtual]`

Returns whether a password hash needs to be updated (recomputed).

A `hash` may need to be updated if it has been computed with a cryptographic method that is being disfavoured.

Implements Wt::Auth::PasswordService::AbstractVerifier.

void Wt::Auth::PasswordVerifier::setSaltLength | ( | int | words | ) |

Sets the salt length.

The salt length is used to create new salt when a new password is being hashed.

The salt length is specified in bytes, but should be a multiple of 3 (so that Base64 encoding yields an integral number of bytes).

The default length is 12.

See also:
  hashPassword()

bool Wt::Auth::PasswordVerifier::verify | ( | const WString & | password,
|  | const PasswordHash & | hash
| ) |  | const`[virtual]`

Verifies a password against a hash.

This verifies whether the password matches the hash.

See also:
  hashPassword()

Implements Wt::Auth::PasswordService::AbstractVerifier.

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator